SET TERMOUT OFF;
SET TRIMSPOOL ON;	
SET WRAP OFF;
SET TRIMOUT ON;
SET NEWPAGE NONE;
SET COLSEP ';'
SET LINESIZE 5000;
SET PAGESIZE 0;
SET FEEDBACK OFF;
SET VERIFY OFF;
SET HEADING OFF;
SET ECHO OFF;
SET EMBEDDED ON;

COLUMN ARTICLE FORMAT A7;

CREATE OR REPLACE FUNCTION get_hierarchy(delimiter IN VARCHAR2, node IN VARCHAR2) RETURN VARCHAR2 IS
    hier_path VARCHAR2(2000);
    parent_node VARCHAR2(100);
    node_name VARCHAR2(200);
BEGIN
    SELECT    TREE
        INTO  parent_node
        FROM  SACARDCLASS
        WHERE ID = node;
    WHILE parent_node IS NOT NULL LOOP
        SELECT    SUBSTR(TREE, 1, INSTR(TREE, '.', -2)),
                  NAME
            INTO  parent_node,
                  node_name
            FROM  SACARDCLASS
            WHERE TREE = parent_node;
        hier_path := CASE WHEN hier_path IS NOT NULL THEN
            node_name || delimiter || hier_path
        ELSE
            node_name
        END;
    END LOOP;
    RETURN hier_path;
END;
/

COLUMN spoolfile NEW_VALUE spoolfile;
SELECT '&1\\'||TO_CHAR(SYSDATE, 'YYYYMMDD_HH24MISS')||'.csv' spoolfile FROM DUAL;
SPOOL '&spoolfile';
    SELECT    REPLACE(SMCARD.NAME, ';', '\;')
              ||';'|| REPLACE(get_hierarchy('&&', IDCLASS), ',', '\,')
              ||';'|| 0
              ||';'|| article
        FROM  SMCARD
              JOIN SACARDCLASS
              ON SMCARD.IDCLASS = SACARDCLASS.ID
        WHERE article != '0'
        ORDER BY article;
SPOOL OFF;
EXIT;